function read_wobj(dimentionSize,numersCubes,folder)
switch nargin
    case 2
        folder='./output/';
    case 1
        folder='./output/';
        dimentionSize=3;
    otherwise
       folder='./output/';
       dimentionSize=3;
       numersCubes=20;
end





ID=0;
face_temp = [-8 -7 -6 -5; ...
        -1 -2 -3 -4; ...
        -5 -6 -2 -1; ...
        -4 -8 -5 -1; ...
        -4 -3 -7 -8; ...
        -7 -3 -2 -6];
cube_history{1}=zeros(dimentionSize,dimentionSize,dimentionSize);
SummaryFileID = fopen([folder 'summary.csv'],'w');
nextfolder=0;
while ID<numersCubes
    cube = round(rand(dimentionSize,dimentionSize,dimentionSize));
    
    [cubeX,cubeY,cubeZ]=ind2sub(size(cube),find(cube));
    if min(cubeX)==1 & max(cubeX)==dimentionSize &...
            min(cubeY)==1 & max(cubeY)==dimentionSize &...
            min(cubeZ)==1 & max(cubeZ)==dimentionSize &...
            any(cellfun(@(x)isequal(x,cube),cube_history))~=1 %look up if cube already was created

        cube_history{size(cube_history,2)+1}=cube;

        vertex= double.empty(0,3);
        for idx = 1:numel(cube)
            [cubeX,cubeY,cubeZ] = ind2sub(size(cube),idx);
            if cube(idx)
                vertex_temp = [cubeX cubeY+1 cubeZ+1; ...
                    cubeX cubeY cubeZ+1; ...
                    cubeX+1 cubeY cubeZ+1; ...
                    cubeX+1 cubeY+1 cubeZ+1; ...
                    cubeX cubeY+1 cubeZ; ...
                    cubeX cubeY cubeZ; ...
                    cubeX+1 cubeY cubeZ; ...
                    cubeX+1 cubeY+1 cubeZ];
                vertex_temp = vertex_temp -1;
                vertex=cat(1,vertex,vertex_temp);
            end
        end
        
        if mod(ID,10000)==0
            nextfolder=nextfolder+1;
            subname=sprintf('sub%02d/',nextfolder);
            mkdir([folder subname]);
        end
        filename=sprintf('%06d_Cube',ID);
        fileID = fopen([folder subname filename '.obj'],'w');
        save([folder subname filename '.mat'],'cube');
        fprintf(fileID,'#3D Reconstruction Cube <%1.0f,%1.0f,%1.0f> by Julius Schöning (juschoening@uos.de)\n',size(cube,1),size(cube,2),size(cube,3));
        fprintf(fileID,'#Cube ID %06d\n',ID);
        fprintf(fileID,'o CubeID_%06d\n',ID);
        for x=1:size(vertex,1)
            fprintf(fileID,'v %9.8f %9.8f %9.8f\n',vertex(x,1),vertex(x,2),vertex(x,3));

            if mod(x,8)==0
                for y=1:size(face_temp,1)
                fprintf(fileID,'f %1.0f %1.0f %1.0f %1.0f\n',face_temp(y,1),face_temp(y,2),face_temp(y,3),face_temp(y,4));
                end
            end
        end
        fclose(fileID);
        OBJ=read_wobj([folder subname filename '.obj']);%resave the obj to get a common ordering of faces
        write_wobj(OBJ,[folder subname filename '.obj']);

        string='%s';
        for x=1:numel(cube)
            string=[string ' %1.0f'];
        end
        string=[string '\n'];
        cubeR=reshape(cube,[1,numel(cube)]);
        fprintf(SummaryFileID,string,filename,cubeR);
        ID=ID+1;
    end
end
fclose(SummaryFileID);
end
